Index: /trunk/demos/SimpleFleet/uav/src/SimpleFleet.cpp
===================================================================
--- /trunk/demos/SimpleFleet/uav/src/SimpleFleet.cpp	(revision 121)
+++ /trunk/demos/SimpleFleet/uav/src/SimpleFleet.cpp	(revision 122)
@@ -50,16 +50,21 @@
 
 
-SimpleFleet::SimpleFleet(flair::meta::Uav* uav,string broadcast,TargetController *controller): UavStateMachine(uav,controller), behaviourMode(BehaviourMode_t::Default), vrpnLost(false) {
-    uav->SetupVRPNAutoIP(uav->ObjectName());
-
-    circle=new TrajectoryGenerator2DCircle(uav->GetVrpnClient()->GetLayout()->NewRow(),"circle");
-    uav->GetVrpnObject()->xPlot()->AddCurve(circle->Matrix()->Element(0,0),0,0,255);
-    uav->GetVrpnObject()->yPlot()->AddCurve(circle->Matrix()->Element(0,1),0,0,255);
-    uav->GetVrpnObject()->VxPlot()->AddCurve(circle->Matrix()->Element(1,0),0,0,255);
-    uav->GetVrpnObject()->VyPlot()->AddCurve(circle->Matrix()->Element(1,1),0,0,255);
-
-    xCircleCenter=new DoubleSpinBox(uav->GetVrpnClient()->GetLayout()->NewRow(),"x circle center"," m",-5,5,0.1,1,0);
-    yCircleCenter=new DoubleSpinBox(uav->GetVrpnClient()->GetLayout()->NewRow(),"y circle center"," m",-5,5,0.1,1,0);
-    yDisplacement=new DoubleSpinBox(uav->GetVrpnClient()->GetLayout()->NewRow(),"y displacement"," m",0,2,0.1,1,0);
+SimpleFleet::SimpleFleet(string broadcast,TargetController *controller): UavStateMachine(controller), behaviourMode(BehaviourMode_t::Default), vrpnLost(false) {
+    Uav* uav=GetUav();
+		
+		VrpnClient* vrpnclient=new VrpnClient("vrpn", uav->GetDefaultVrpnAddress(),10000, 80);
+		uavVrpn = new MetaVrpnObject(uav->ObjectName());
+		getFrameworkManager()->AddDeviceToLog(uavVrpn);
+		uav->GetAhrs()->YawPlot()->AddCurve(uavVrpn->State()->Element(2),DataPlot::Green);
+
+    circle=new TrajectoryGenerator2DCircle(vrpnclient->GetLayout()->NewRow(),"circle");
+    uavVrpn->xPlot()->AddCurve(circle->Matrix()->Element(0,0),0,0,255);
+    uavVrpn->yPlot()->AddCurve(circle->Matrix()->Element(0,1),0,0,255);
+    uavVrpn->VxPlot()->AddCurve(circle->Matrix()->Element(1,0),0,0,255);
+    uavVrpn->VyPlot()->AddCurve(circle->Matrix()->Element(1,1),0,0,255);
+
+    xCircleCenter=new DoubleSpinBox(vrpnclient->GetLayout()->NewRow(),"x circle center"," m",-5,5,0.1,1,0);
+    yCircleCenter=new DoubleSpinBox(vrpnclient->GetLayout()->NewRow(),"y circle center"," m",-5,5,0.1,1,0);
+    yDisplacement=new DoubleSpinBox(vrpnclient->GetLayout()->NewRow(),"y displacement"," m",0,2,0.1,1,0);
 
     //parent->AddDeviceToLog(Uz());
@@ -101,5 +106,5 @@
     //get yaw from vrpn
     Euler vrpnEuler;
-    GetUav()->GetVrpnObject()->GetEuler(vrpnEuler);
+    uavVrpn->GetEuler(vrpnEuler);
 
     //get roll, pitch and w from imu
@@ -120,6 +125,6 @@
     Vector3D uav_pos,uav_vel;
 
-    GetUav()->GetVrpnObject()->GetPosition(uav_pos);
-    GetUav()->GetVrpnObject()->GetSpeed(uav_vel);
+    uavVrpn->GetPosition(uav_pos);
+    uavVrpn->GetSpeed(uav_vel);
     //z and dz must be in uav's frame
     z=-uav_pos.z;
@@ -154,7 +159,7 @@
     Euler vrpn_euler; // in VRPN coordinate system
 
-    GetUav()->GetVrpnObject()->GetPosition(uav_pos);
-    GetUav()->GetVrpnObject()->GetSpeed(uav_vel);
-    GetUav()->GetVrpnObject()->GetEuler(vrpn_euler);
+    uavVrpn->GetPosition(uav_pos);
+    uavVrpn->GetSpeed(uav_vel);
+    uavVrpn->GetEuler(vrpn_euler);
 
     uav_pos.To2Dxy(uav_2Dpos);
@@ -294,5 +299,5 @@
 void SimpleFleet::ExtraSecurityCheck(void) {
     if (!vrpnLost && behaviourMode!=BehaviourMode_t::Default) {
-        if (!GetUav()->GetVrpnObject()->IsTracked(500)) {
+        if (!uavVrpn->IsTracked(500)) {
             Thread::Err("Optitrack, uav lost\n");
             vrpnLost=true;
@@ -322,5 +327,5 @@
     circle->SetCenter(target_2Dpos);
 
-    GetUav()->GetVrpnObject()->GetPosition(uav_pos);
+    uavVrpn->GetPosition(uav_pos);
     uav_pos.To2Dxy(uav_2Dpos);
     circle->StartTraj(uav_2Dpos,1);
@@ -347,8 +352,8 @@
     }
 
-    GetUav()->GetVrpnObject()->GetEuler(vrpn_euler);
+    uavVrpn->GetEuler(vrpn_euler);
     yaw_hold=vrpn_euler.yaw;
 
-    GetUav()->GetVrpnObject()->GetPosition(vrpn_pos);
+    uavVrpn->GetPosition(vrpn_pos);
     vrpn_pos.To2Dxy(pos_hold);
 
Index: /trunk/demos/SimpleFleet/uav/src/SimpleFleet.h
===================================================================
--- /trunk/demos/SimpleFleet/uav/src/SimpleFleet.h	(revision 121)
+++ /trunk/demos/SimpleFleet/uav/src/SimpleFleet.h	(revision 122)
@@ -26,4 +26,7 @@
         class TrajectoryGenerator2DCircle;
     }
+		namespace meta {
+        class MetaVrpnObject;
+    }
     namespace gui {
         class DoubleSpinBox;
@@ -34,5 +37,5 @@
 class SimpleFleet : public flair::meta::UavStateMachine {
     public:
-        SimpleFleet(flair::meta::Uav* uav,std::string broadcast,flair::sensor::TargetController *controller);
+        SimpleFleet(std::string broadcast,flair::sensor::TargetController *controller);
         ~SimpleFleet();
 
@@ -75,4 +78,5 @@
         flair::gui::DoubleSpinBox *xCircleCenter,*yCircleCenter,*yDisplacement;
         flair::core::AhrsData *customReferenceOrientation,*customOrientation;
+				flair::meta::MetaVrpnObject *uavVrpn;
 };
 
Index: /trunk/demos/SimpleFleet/uav/src/main.cpp
===================================================================
--- /trunk/demos/SimpleFleet/uav/src/main.cpp	(revision 121)
+++ /trunk/demos/SimpleFleet/uav/src/main.cpp	(revision 122)
@@ -46,7 +46,7 @@
     manager->SetupUserInterface(xml_file);
 
-    Uav* drone=CreateUav(manager,name,uav_type);
+    Uav* drone=CreateUav(name,uav_type);
     TargetEthController *controller=new TargetEthController(manager,"Dualshock3",ds3port);
-    SimpleFleet* demo=new SimpleFleet(drone,broadcast,controller);
+    SimpleFleet* demo=new SimpleFleet(broadcast,controller);
 
     demo->Start();
Index: /trunk/demos/Skeletons/CustomReferenceAngles/CMakeLists.txt
===================================================================
--- /trunk/demos/Skeletons/CustomReferenceAngles/CMakeLists.txt	(revision 121)
+++ /trunk/demos/Skeletons/CustomReferenceAngles/CMakeLists.txt	(revision 122)
@@ -6,5 +6,4 @@
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
 SET(FLAIR_USE_META TRUE)
-SET(FLAIR_USE_VRPN TRUE)
 
 include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
Index: /trunk/demos/Skeletons/CustomReferenceAngles/src/MyApp.cpp
===================================================================
--- /trunk/demos/Skeletons/CustomReferenceAngles/src/MyApp.cpp	(revision 121)
+++ /trunk/demos/Skeletons/CustomReferenceAngles/src/MyApp.cpp	(revision 122)
@@ -29,10 +29,10 @@
 using namespace flair::sensor;
 
-MyApp::MyApp(Uav* uav,TargetController *controller): UavStateMachine(uav,controller), behaviourMode(BehaviourMode_t::Default) {
+MyApp::MyApp(TargetController *controller): UavStateMachine(controller), behaviourMode(BehaviourMode_t::Default) {
     start_CustomAngles=new PushButton(GetButtonsLayout()->NewRow(),"start CustomReferenceAngles");
     stop_CustomAngles=new PushButton(GetButtonsLayout()->NewRow(),"stop CustomReferenceAngles");
 
     customReferenceOrientation= new AhrsData(this,"reference");
-    uav->GetAhrs()->AddPlot(customReferenceOrientation,DataPlot::Yellow);
+    GetUav()->GetAhrs()->AddPlot(customReferenceOrientation,DataPlot::Yellow);
     AddDataToControlLawLog(customReferenceOrientation);
 }
Index: /trunk/demos/Skeletons/CustomReferenceAngles/src/MyApp.h
===================================================================
--- /trunk/demos/Skeletons/CustomReferenceAngles/src/MyApp.h	(revision 121)
+++ /trunk/demos/Skeletons/CustomReferenceAngles/src/MyApp.h	(revision 122)
@@ -31,5 +31,5 @@
 class MyApp : public flair::meta::UavStateMachine {
     public:
-        MyApp(flair::meta::Uav* uav,flair::sensor::TargetController *controller);
+        MyApp(flair::sensor::TargetController *controller);
         ~MyApp();
 
Index: /trunk/demos/Skeletons/CustomReferenceAngles/src/main.cpp
===================================================================
--- /trunk/demos/Skeletons/CustomReferenceAngles/src/main.cpp	(revision 121)
+++ /trunk/demos/Skeletons/CustomReferenceAngles/src/main.cpp	(revision 122)
@@ -44,7 +44,7 @@
     manager->SetupLogger(log_path);
 
-    Uav* drone=CreateUav(manager,name,uav_type);
+    Uav* drone=CreateUav(name,uav_type);
     TargetEthController *controller=new TargetEthController(manager,"Dualshock3",ds3port);
-    MyApp* app=new MyApp(drone,controller);
+    MyApp* app=new MyApp(controller);
 
     app->Start();
Index: /trunk/demos/Skeletons/CustomTorques/CMakeLists.txt
===================================================================
--- /trunk/demos/Skeletons/CustomTorques/CMakeLists.txt	(revision 121)
+++ /trunk/demos/Skeletons/CustomTorques/CMakeLists.txt	(revision 122)
@@ -6,5 +6,4 @@
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
 SET(FLAIR_USE_META TRUE)
-SET(FLAIR_USE_VRPN TRUE)
 
 include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
Index: /trunk/demos/Skeletons/CustomTorques/src/MyApp.cpp
===================================================================
--- /trunk/demos/Skeletons/CustomTorques/src/MyApp.cpp	(revision 121)
+++ /trunk/demos/Skeletons/CustomTorques/src/MyApp.cpp	(revision 122)
@@ -26,5 +26,5 @@
 using namespace flair::sensor;
 
-MyApp::MyApp(Uav* uav,TargetController *controller): UavStateMachine(uav,controller), behaviourMode(BehaviourMode_t::Default) {
+MyApp::MyApp(TargetController *controller): UavStateMachine(controller), behaviourMode(BehaviourMode_t::Default) {
     start_CustomTorques=new PushButton(GetButtonsLayout()->NewRow(),"start CustomTorques");
     stop_CustomTorques=new PushButton(GetButtonsLayout()->NewRow(),"stop CustomTorques");
Index: /trunk/demos/Skeletons/CustomTorques/src/MyApp.h
===================================================================
--- /trunk/demos/Skeletons/CustomTorques/src/MyApp.h	(revision 121)
+++ /trunk/demos/Skeletons/CustomTorques/src/MyApp.h	(revision 122)
@@ -28,5 +28,5 @@
 class MyApp : public flair::meta::UavStateMachine {
     public:
-        MyApp(flair::meta::Uav* uav,flair::sensor::TargetController *controller);
+        MyApp(flair::sensor::TargetController *controller);
         ~MyApp();
 
Index: /trunk/demos/Skeletons/CustomTorques/src/main.cpp
===================================================================
--- /trunk/demos/Skeletons/CustomTorques/src/main.cpp	(revision 121)
+++ /trunk/demos/Skeletons/CustomTorques/src/main.cpp	(revision 122)
@@ -45,7 +45,7 @@
     manager->SetupLogger(log_path);
 
-    Uav* drone=CreateUav(manager,name,uav_type);
+    Uav* drone=CreateUav(name,uav_type);
     TargetEthController *controller=new TargetEthController(manager,"Dualshock3",ds3port);
-    MyApp* app=new MyApp(drone,controller);
+    MyApp* app=new MyApp(controller);
 
     app->Start();
Index: /trunk/lib/FlairCore/src/FrameworkManager.cpp
===================================================================
--- /trunk/lib/FlairCore/src/FrameworkManager.cpp	(revision 121)
+++ /trunk/lib/FlairCore/src/FrameworkManager.cpp	(revision 122)
@@ -178,4 +178,8 @@
 }
 
+bool FrameworkManager::IsDeviceLogged(const IODevice *device) const {
+	return pimpl_->IsDeviceLogged(device);
+}
+
 void FrameworkManager::StartLog(void) { pimpl_->StartLog(); }
 
Index: /trunk/lib/FlairCore/src/FrameworkManager.h
===================================================================
--- /trunk/lib/FlairCore/src/FrameworkManager.h	(revision 121)
+++ /trunk/lib/FlairCore/src/FrameworkManager.h	(revision 122)
@@ -121,4 +121,14 @@
   */
   void AddDeviceToLog(IODevice *device);
+	
+	/*!
+  * \brief Is device logged
+  *
+  * Check if AddDeviceToLog was called for an IODevice
+  *
+  * \param device IODevice to check
+  * \return true if AddDeviceToLog was called for this IODevice
+  */
+  bool IsDeviceLogged(const IODevice *device) const;
 
   /*!
Index: /trunk/lib/FlairCore/src/FrameworkManager_impl.cpp
===================================================================
--- /trunk/lib/FlairCore/src/FrameworkManager_impl.cpp	(revision 121)
+++ /trunk/lib/FlairCore/src/FrameworkManager_impl.cpp	(revision 122)
@@ -630,5 +630,6 @@
 
   if (is_logging == false) {
-    if (device->pimpl_->SetToBeLogged()) {
+    if (!device->pimpl_->IsSetToBeLogged()) {
+			device->pimpl_->SetToBeLogged();
       log_desc_t tmp;
       tmp.device = device;
@@ -640,4 +641,8 @@
     Err("impossible while logging\n");
   }
+}
+
+bool FrameworkManager_impl::IsDeviceLogged(const IODevice *device) const {
+	return device->pimpl_->IsSetToBeLogged();
 }
 
Index: /trunk/lib/FlairCore/src/IODevice_impl.cpp
===================================================================
--- /trunk/lib/FlairCore/src/IODevice_impl.cpp	(revision 121)
+++ /trunk/lib/FlairCore/src/IODevice_impl.cpp	(revision 122)
@@ -106,16 +106,19 @@
 }
 
-bool IODevice_impl::SetToBeLogged(void) {
+bool IODevice_impl::IsSetToBeLogged(void) const{
+	return tobelogged;
+}
+
+void IODevice_impl::SetToBeLogged(void) {
   if (!tobelogged) {
     tobelogged = true;
-    return true;
   } else {
     self->Warn("already added to log\n");
-    return false;
   }
 }
 
 void IODevice_impl::WriteLogsDescriptors(fstream &desc_file, int *index) {
-  // own descriptor
+  //Printf("WriteLogsDescriptors %s\n",self->ObjectName().c_str());
+	// own descriptor
   for (size_t i = 0; i < datasToLog.size(); i++)
     datasToLog.at(i)->pimpl_->WriteLogDescriptor(desc_file, index);
@@ -127,4 +130,5 @@
   for (size_t i = 0; i < devicesToLog.size(); i++)
     devicesToLog.at(i)->pimpl_->WriteLogsDescriptors(desc_file, index);
+	//Printf("WriteLogsDescriptors %s ok\n",self->ObjectName().c_str());
 }
 
@@ -194,9 +198,9 @@
 
 void IODevice_impl::AppendLog(char **ptr) {
-  // Printf("AppendLog %s %x\n",self->ObjectName().c_str(),*ptr);
+   //Printf("AppendLog %s %x\n",self->ObjectName().c_str(),*ptr);
 
   // copy state to buf
   for (size_t i = 0; i < datasToLog.size(); i++) {
-    // printf("copy\n");
+    // printf("copy %s\n",datasToLog.at(i)->ObjectName().c_str());
     datasToLog.at(i)->CopyDatas(*ptr);
     (*ptr) += datasToLog.at(i)->GetDataType().GetSize();
Index: /trunk/lib/FlairCore/src/io_data_impl.cpp
===================================================================
--- /trunk/lib/FlairCore/src/io_data_impl.cpp	(revision 121)
+++ /trunk/lib/FlairCore/src/io_data_impl.cpp	(revision 122)
@@ -42,4 +42,5 @@
 
 void io_data_impl::WriteLogDescriptor(std::fstream &desc_file, int *index) {
+	if(descriptors.size()==0) self->Warn("AppendLogDescription was not called for this object.\n");
   for (size_t i = 0; i < descriptors.size(); i++) {
     desc_file << (*index)++ << ": " << self->ObjectName() << " - "
Index: /trunk/lib/FlairCore/src/unexported/FrameworkManager_impl.h
===================================================================
--- /trunk/lib/FlairCore/src/unexported/FrameworkManager_impl.h	(revision 121)
+++ /trunk/lib/FlairCore/src/unexported/FrameworkManager_impl.h	(revision 122)
@@ -48,4 +48,5 @@
   void SetupLogger(std::string log_path);
   void AddDeviceToLog(flair::core::IODevice *device);
+	bool IsDeviceLogged(const flair::core::IODevice *device) const;
   void StartLog();
   void StopLog();
Index: /trunk/lib/FlairCore/src/unexported/IODevice_impl.h
===================================================================
--- /trunk/lib/FlairCore/src/unexported/IODevice_impl.h	(revision 121)
+++ /trunk/lib/FlairCore/src/unexported/IODevice_impl.h	(revision 122)
@@ -42,5 +42,6 @@
   void WriteLog(flair::core::Time time);
   void AddDeviceToLog(const flair::core::IODevice *device);
-  bool SetToBeLogged(void); // return true if possible
+  void SetToBeLogged(void); 
+	bool IsSetToBeLogged(void) const;
   void OutputToShMem(bool enabled);
   void WriteToShMem(void);
Index: /trunk/lib/FlairMeta/src/HdsX8.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/HdsX8.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/HdsX8.cpp	(revision 122)
@@ -35,32 +35,20 @@
 namespace meta {
 
-HdsX8::HdsX8(FrameworkManager *parent, string uav_name,
+HdsX8::HdsX8(string name,
              filter::UavMultiplex *multiplex)
-    : Uav(parent, uav_name, multiplex) {
-  RTDM_I2cPort *i2cport = new RTDM_I2cPort(parent, "rtdm_i2c", "rti2c3");
-  RTDM_SerialPort *imu_port = new RTDM_SerialPort(parent, "imu_port", "rtser1");
+    : Uav(name, multiplex) {
+  RTDM_I2cPort *i2cport = new RTDM_I2cPort(getFrameworkManager(), "rtdm_i2c", "rti2c3");
+  RTDM_SerialPort *imu_port = new RTDM_SerialPort(getFrameworkManager(), "imu_port", "rtser1");
 
   if (multiplex == NULL)
-    SetMultiplex(new X4X8Multiplex(parent, "motors", X4X8Multiplex::X8));
+    SetMultiplex(new X4X8Multiplex(getFrameworkManager(), "motors", X4X8Multiplex::X8));
 
   SetBldc(new BlCtrlV2(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
                        "motors", GetUavMultiplex()->MotorsCount(), i2cport));
-  SetUsRangeFinder(new Srf08(parent, "SRF08", i2cport, 0x70, 60));
-  SetAhrs(new Gx3_25_ahrs(parent, "imu", imu_port,
+  SetUsRangeFinder(new Srf08(getFrameworkManager(), "SRF08", i2cport, 0x70, 60));
+  SetAhrs(new Gx3_25_ahrs(getFrameworkManager(), "imu", imu_port,
                           Gx3_25_imu::AccelerationAngularRateAndOrientationMatrix, 70));
   SetBatteryMonitor(((BlCtrlV2 *)GetBldc())->GetBatteryMonitor());
-
-  /*
-          if(VRPNType==Auto || VRPNType==AutoSerialPort)
-          {
-              RTDM_SerialPort* vrpn_port=new
-     RTDM_SerialPort(parent,"vrpn_port","rtser3");
-
-              vrpnclient=new VrpnClient(parent,"vrpn",vrpn_port,10000,80);
-              uav_vrpn=new
-     MetaVrpnObject(vrpnclient,uav_name,VRPNSerialObjectId);
-          }
-  */
-  SetVerticalCamera(new Ps3Eye(parent, "camv", 0, 50));
+  SetVerticalCamera(new Ps3Eye(getFrameworkManager(), "camv", 0, 50));
 }
 
@@ -71,5 +59,4 @@
   ((Srf08 *)GetUsRangeFinder())->Start();
   ((Ps3Eye *)GetVerticalCamera())->Start();
-  Uav::StartSensors();
 }
 
Index: /trunk/lib/FlairMeta/src/HdsX8.h
===================================================================
--- /trunk/lib/FlairMeta/src/HdsX8.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/HdsX8.h	(revision 122)
@@ -24,8 +24,9 @@
 class HdsX8 : public Uav {
 public:
-  HdsX8(core::FrameworkManager *parent, std::string uav_name,
+  HdsX8(std::string name,
         filter::UavMultiplex *multiplex = NULL);
   ~HdsX8();
   void StartSensors(void);
+	std::string GetDefaultVrpnAddress(void) const{return "192.168.147.197:3883";}
 
 private:
Index: /trunk/lib/FlairMeta/src/MetaVrpnObject.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/MetaVrpnObject.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/MetaVrpnObject.cpp	(revision 122)
@@ -39,16 +39,16 @@
 namespace meta {
 
-MetaVrpnObject::MetaVrpnObject(const VrpnClient *parent, string name)
-    : VrpnObject(parent, name, parent->GetTabWidget()) {
-  ConstructorCommon(parent, name);
+MetaVrpnObject::MetaVrpnObject(string name)
+    : VrpnObject( name, GetVrpnClient()->GetTabWidget()) {
+  ConstructorCommon(name);
 }
 
-MetaVrpnObject::MetaVrpnObject(const VrpnClient *parent, std::string name,
+MetaVrpnObject::MetaVrpnObject(std::string name,
                                uint8_t id)
-    : VrpnObject(parent, name, id, parent->GetTabWidget()) {
-  ConstructorCommon(parent, name);
+    : VrpnObject(name, id, GetVrpnClient()->GetTabWidget()) {
+  ConstructorCommon( name);
 }
 
-void MetaVrpnObject::ConstructorCommon(const VrpnClient *parent, string name) {
+void MetaVrpnObject::ConstructorCommon(string name) {
   cvmatrix_descriptor *desc = new cvmatrix_descriptor(6, 1);
   for (int i = 0; i < 6; i++) {
@@ -60,5 +60,5 @@
   }
 
-  pbas = new LowPassFilter(this, parent->GetLayout()->NewRow(),
+  pbas = new LowPassFilter(this, GetVrpnClient()->GetLayout()->NewRow(),
                            name + " Passe bas", prev_value);
 
@@ -72,5 +72,5 @@
   }
 
-  euler = new EulerDerivative(pbas, parent->GetLayout()->NewRow(),
+  euler = new EulerDerivative(pbas, GetVrpnClient()->GetLayout()->NewRow(),
                               name + "_euler", prev_value);
 
@@ -82,5 +82,5 @@
   vz_opti_plot->AddCurve(euler->Matrix()->Element(5));
 
-  plot_tab = new Tab(parent->GetTabWidget(), "Mesures (xy) " + name);
+  plot_tab = new Tab(GetVrpnClient()->GetTabWidget(), "Mesures (xy) " + name);
   xy_plot = new DataPlot2D(plot_tab->NewRow(), "xy", "y", -5, 5, "x", -5, 5);
   xy_plot->AddCurve(Output()->Element(4, 0), Output()->Element(3, 0));
Index: /trunk/lib/FlairMeta/src/MetaVrpnObject.h
===================================================================
--- /trunk/lib/FlairMeta/src/MetaVrpnObject.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/MetaVrpnObject.h	(revision 122)
@@ -18,20 +18,17 @@
 
 namespace flair {
-namespace core {
-class Vector3D;
-class FloatType;
-}
-namespace gui {
-class DataPlot1D;
-class DataPlot2D;
-class Tab;
-}
-namespace filter {
-class EulerDerivative;
-class LowPassFilter;
-}
-namespace sensor {
-class VrpnClient;
-}
+	namespace core {
+		class Vector3D;
+		class FloatType;
+	}
+	namespace gui {
+		class DataPlot1D;
+		class DataPlot2D;
+		class Tab;
+	}
+	namespace filter {
+		class EulerDerivative;
+		class LowPassFilter;
+	}
 }
 
@@ -47,7 +44,6 @@
 class MetaVrpnObject : public sensor::VrpnObject {
 public:
-  MetaVrpnObject(const sensor::VrpnClient *parent, std::string name);
-  MetaVrpnObject(const sensor::VrpnClient *parent, std::string name,
-                 uint8_t id);
+  MetaVrpnObject(std::string name);
+  MetaVrpnObject(std::string name,uint8_t id);
   ~MetaVrpnObject();
   gui::DataPlot1D *VxPlot(void) const; // 1,0
@@ -58,5 +54,5 @@
 
 private:
-  void ConstructorCommon(const sensor::VrpnClient *parent, std::string name);
+  void ConstructorCommon(std::string name);
   filter::LowPassFilter *pbas;
   filter::EulerDerivative *euler;
Index: /trunk/lib/FlairMeta/src/SimuX4.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/SimuX4.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/SimuX4.cpp	(revision 122)
@@ -37,20 +37,20 @@
 namespace meta {
 
-SimuX4::SimuX4(FrameworkManager *parent, string uav_name, int simu_id,
+SimuX4::SimuX4(string name, int simu_id,
                filter::UavMultiplex *multiplex)
-    : Uav(parent, uav_name, multiplex) {
+    : Uav(name, multiplex) {
 
   if (multiplex == NULL)
-    SetMultiplex(new X4X8Multiplex(parent, "motors", X4X8Multiplex::X4));
+    SetMultiplex(new X4X8Multiplex(getFrameworkManager(), "motors", X4X8Multiplex::X4));
 
   SetBldc(new SimuBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
                        "motors", GetUavMultiplex()->MotorsCount(), simu_id));
-  SetUsRangeFinder(new SimuUs(parent, "us", simu_id, 60));
-  SetAhrs(new SimuAhrs(parent, "imu", simu_id, 70));
-  Tab *bat_tab = new Tab(parent->GetTabWidget(), "battery");
+  SetUsRangeFinder(new SimuUs(getFrameworkManager(), "us", simu_id, 60));
+  SetAhrs(new SimuAhrs(getFrameworkManager(), "imu", simu_id, 70));
+  Tab *bat_tab = new Tab(getFrameworkManager()->GetTabWidget(), "battery");
   SetBatteryMonitor(new BatteryMonitor(bat_tab->NewRow(), "battery"));
   GetBatteryMonitor()->SetBatteryValue(12);
   SetVerticalCamera(
-      new SimuCamera(parent, "simu_cam_v", 320, 240, 3, simu_id, 10));
+      new SimuCamera(getFrameworkManager(), "simu_cam_v", 320, 240, 3, simu_id, 10));
 }
 
@@ -61,8 +61,5 @@
   ((SimuUs *)GetUsRangeFinder())->Start();
   ((SimuCamera *)GetVerticalCamera())->Start();
-  Uav::StartSensors();
 }
-
-void SimuX4::SetupVRPNAutoIP(string name) { SetupVRPN("127.0.0.1:3883", name); }
 
 } // end namespace meta
Index: /trunk/lib/FlairMeta/src/SimuX4.h
===================================================================
--- /trunk/lib/FlairMeta/src/SimuX4.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/SimuX4.h	(revision 122)
@@ -26,9 +26,8 @@
   // simu_id: 0 if simulating only one UAV
   //>0 otherwise
-  SimuX4(core::FrameworkManager *parent, std::string uav_name, int simu_id = 0,
+  SimuX4(std::string name, int simu_id = 0,
          filter::UavMultiplex *multiplex = NULL);
   ~SimuX4();
   void StartSensors(void);
-  void SetupVRPNAutoIP(std::string name);
 };
 } // end namespace meta
Index: /trunk/lib/FlairMeta/src/SimuX8.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/SimuX8.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/SimuX8.cpp	(revision 122)
@@ -37,20 +37,20 @@
 namespace meta {
 
-SimuX8::SimuX8(FrameworkManager *parent, string uav_name, int simu_id,
+SimuX8::SimuX8(string name, int simu_id,
                filter::UavMultiplex *multiplex)
-    : Uav(parent, uav_name, multiplex) {
+    : Uav(name, multiplex) {
 
   if (multiplex == NULL)
-    SetMultiplex(new X4X8Multiplex(parent, "motors", X4X8Multiplex::X8));
+    SetMultiplex(new X4X8Multiplex(getFrameworkManager(), "motors", X4X8Multiplex::X8));
 
   SetBldc(new SimuBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
                        "motors", GetUavMultiplex()->MotorsCount(), simu_id));
-  SetUsRangeFinder(new SimuUs(parent, "us", simu_id, 60));
-  SetAhrs(new SimuAhrs(parent, "imu", simu_id, 70));
-  Tab *bat_tab = new Tab(parent->GetTabWidget(), "battery");
+  SetUsRangeFinder(new SimuUs(getFrameworkManager(), "us", simu_id, 60));
+  SetAhrs(new SimuAhrs(getFrameworkManager(), "imu", simu_id, 70));
+  Tab *bat_tab = new Tab(getFrameworkManager()->GetTabWidget(), "battery");
   SetBatteryMonitor(new BatteryMonitor(bat_tab->NewRow(), "battery"));
   GetBatteryMonitor()->SetBatteryValue(12);
   SetVerticalCamera(
-      new SimuCamera(parent, "simu_cam_v", 320, 240, 3, simu_id, 10));
+      new SimuCamera(getFrameworkManager(), "simu_cam_v", 320, 240, 3, simu_id, 10));
 }
 
@@ -61,8 +61,5 @@
   ((SimuUs *)GetUsRangeFinder())->Start();
   ((SimuCamera *)GetVerticalCamera())->Start();
-  Uav::StartSensors();
 }
-
-void SimuX8::SetupVRPNAutoIP(string name) { SetupVRPN("127.0.0.1:3883", name); }
 
 } // end namespace meta
Index: /trunk/lib/FlairMeta/src/SimuX8.h
===================================================================
--- /trunk/lib/FlairMeta/src/SimuX8.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/SimuX8.h	(revision 122)
@@ -26,9 +26,8 @@
   // simu_id: 0 if simulating only one UAV
   //>0 otherwise
-  SimuX8(core::FrameworkManager *parent, std::string uav_name, int simu_id = 0,
+  SimuX8(std::string name, int simu_id = 0,
          filter::UavMultiplex *multiplex = NULL);
   ~SimuX8();
   void StartSensors(void);
-  void SetupVRPNAutoIP(std::string name);
 };
 } // end namespace meta
Index: /trunk/lib/FlairMeta/src/Uav.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/Uav.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/Uav.cpp	(revision 122)
@@ -38,11 +38,21 @@
 using namespace flair::actuator;
 
+namespace {
+  flair::meta::Uav *uavSingleton = NULL;
+}
+
 namespace flair {
 namespace meta {
 
-Uav::Uav(FrameworkManager *parent, string name, UavMultiplex *multiplex)
-    : Object(parent, name) {
-  vrpnclient = NULL;
-  uav_vrpn = NULL;
+Uav *GetUav(void) { return uavSingleton; }
+	
+Uav::Uav(string name, UavMultiplex *multiplex)
+    : Object(getFrameworkManager(), name) {
+	if (uavSingleton != NULL) {
+    Err("Uav must be instanced only one time\n");
+    return;
+  }
+
+  uavSingleton = this;
   verticalCamera = NULL;
   horizontalCamera = NULL;
@@ -82,35 +92,5 @@
   horizontalCamera = (Camera *)inHorizontalCamera;
 }
-/*
-void Uav::SetupVRPNSerial(SerialPort *vrpn_port,string name,int
-VRPNSerialObjectId) {
-    vrpnclient=new VrpnClient(getFrameworkManager(),"vrpn",vrpn_port,10000,80);
-    uav_vrpn=new MetaVrpnObject(vrpnclient,name,VRPNSerialObjectId);
 
-    getFrameworkManager()->AddDeviceToLog(uav_vrpn);
-}
-*/
-void Uav::SetupVRPNAutoIP(string name) {
-  SetupVRPN("192.168.147.197:3883", name);
-}
-
-void Uav::SetupVRPN(string optitrack_address, string name) {
-  vrpnclient = new VrpnClient(getFrameworkManager(), "vrpn", optitrack_address,
-                              10000, 80);
-  uav_vrpn = new MetaVrpnObject(vrpnclient, name);
-
-  getFrameworkManager()->AddDeviceToLog(uav_vrpn);
-
-  GetAhrs()->YawPlot()->AddCurve(uav_vrpn->State()->Element(2),
-                                 DataPlot::Green);
-  // GetAhrs()->RollPlot()->AddCurve(uav_vrpn->State()->Element(0),DataPlot::Green);
-  // GetAhrs()->PitchPlot()->AddCurve(uav_vrpn->State()->Element(1),DataPlot::Green);
-}
-
-void Uav::StartSensors(void) {
-  if (vrpnclient != NULL) {
-    vrpnclient->Start();
-  }
-}
 void Uav::UseDefaultPlot(void) {
   multiplex->UseDefaultPlot();
@@ -184,12 +164,4 @@
 BatteryMonitor *Uav::GetBatteryMonitor(void) const { return battery; }
 
-VrpnClient *Uav::GetVrpnClient(void) const {
-  if (vrpnclient == NULL)
-    Err("vrpn is not setup, call SetupVRPN before\n");
-  return vrpnclient;
-}
-
-MetaVrpnObject *Uav::GetVrpnObject(void) const { return uav_vrpn; }
-
 Camera *Uav::GetVerticalCamera(void) const { return verticalCamera; }
 
Index: /trunk/lib/FlairMeta/src/Uav.h
===================================================================
--- /trunk/lib/FlairMeta/src/Uav.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/Uav.h	(revision 122)
@@ -17,21 +17,17 @@
 
 namespace flair {
-namespace core {
-class FrameworkManager;
-}
-namespace filter {
-class Ahrs;
-class UavMultiplex;
-}
-namespace actuator {
-class Bldc;
-}
-namespace sensor {
-class UsRangeFinder;
-class BatteryMonitor;
-class VrpnClient;
-class Imu;
-class Camera;
-}
+	namespace filter {
+		class Ahrs;
+		class UavMultiplex;
+	}
+	namespace actuator {
+		class Bldc;
+	}
+	namespace sensor {
+		class UsRangeFinder;
+		class BatteryMonitor;
+		class Imu;
+		class Camera;
+	}
 }
 
@@ -39,32 +35,20 @@
 namespace meta {
 class MetaUsRangeFinder;
-class MetaVrpnObject;
 
 /*! \class Uav
 *
-* \brief Base class to construct sensors/actuators depending on uav type
+* \brief Base class to construct sensors/actuators depending on uav type.
+* The Object is created with 
+*  the FrameworkManager as parent. FrameworkManager must be created before.
+* Only one instance of this class is allowed by program.
 */
 class Uav : public core::Object {
 public:
-  /*
-      typedef enum {
-          None,
-          Auto,//rt serial if hds x4 ou x8, auto ip sinon
-          AutoIP,
-          UserDefinedIP,
-          AutoSerialPort,
-          } VRPNType_t;
-*/
-  // uav_name: for optitrack
-  Uav(core::FrameworkManager *parent, std::string name,
+
+  Uav(std::string name,
       filter::UavMultiplex *multiplex = NULL);
   ~Uav();
-  void SetupVRPN(std::string optitrack_address, std::string name);
-  // vrpn serial: broken, need to add serial port in uav specific code
-  // void SetupVRPNSerial(core::SerialPort *vrpn_port,std::string name,int
-  // VRPNSerialObjectId);
-  virtual void SetupVRPNAutoIP(std::string name);
 
-  virtual void StartSensors(void);
+  virtual void StartSensors(void)=0;
   void UseDefaultPlot(void);
   actuator::Bldc *GetBldc(void) const;
@@ -75,8 +59,7 @@
   sensor::UsRangeFinder *GetUsRangeFinder(void) const;
   sensor::BatteryMonitor *GetBatteryMonitor(void) const;
-  sensor::VrpnClient *GetVrpnClient(void) const;
-  meta::MetaVrpnObject *GetVrpnObject(void) const;
   sensor::Camera *GetVerticalCamera(void) const;
   sensor::Camera *GetHorizontalCamera(void) const;
+	virtual std::string GetDefaultVrpnAddress(void) const{return "127.0.0.1:3883";}
 
 protected:
@@ -96,9 +79,15 @@
   sensor::UsRangeFinder *us;
   MetaUsRangeFinder *meta_us;
-  sensor::VrpnClient *vrpnclient;
-  MetaVrpnObject *uav_vrpn;
   sensor::BatteryMonitor *battery;
   sensor::Camera *verticalCamera,*horizontalCamera;
 };
+
+/*!
+* \brief get Uav
+*
+* \return the Uav
+*/
+Uav *GetUav(void);
+
 } // end namespace meta
 } // end namespace flair
